<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Jornal_model extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

    /**
     * This funtion takes id as a parameter and will fetch the record.
     * If id is not provided, then it will fetch all the records form the table.
     * @param int $id
     * @return mixed
     */
    public function get($id = null) {

        $userdata = $this->customlib->getUserData();
        $role_id = $userdata["role_id"];
        $carray = array();

            $this->db->select()->from('journal');
            if ($id != null) {
                $this->db->where('id', $id);
            } else {
                $this->db->order_by('id');
            }
            $query = $this->db->get();
            if ($id != null) {
                $grouplist = $query->row_array();
            } else {
                $grouplist = $query->result_array();
            }
            // echo $this->db->last_query();
            // exit();
        return $grouplist;
    }

      //we will use the updating INFO FO
      public function update($id)  
      {  
            $this->db->select()->from('journal');
            if ($id != null) {
                $this->db->where('id', $id);
            } else {
                $this->db->order_by('id');
            }
            $query = $this->db->get();
			
         return $query;  
      }

      public function select()  
      {  
         //data is retrive from this query  
         $query = $this->db->get('journal');  
         return $query;  
      }
      public function selecttemp()  
      {  
         //data is retrive from this query  
         $query = $this->db->get('journaltemp');  
         return $query;  
      }
    /**
     * This function will delete the record based on the id
     * @param $id
     */
    public function remove($id) {
        $this->db->trans_begin();
        $this->db->where('id', $id);
        $this->db->delete('journal'); //class record delete.

       // $this->db->where('group_id', $id);
       // $this->db->delete('uniform_group'); //class_sections record delete.

        if ($this->db->trans_status() === FALSE) {
            $this->db->trans_rollback();
        } else {
            $this->db->trans_commit();
        }
        return TRUE;
    }

// CODE FOR SEARCHING DATES BETWEEN IN CASH BOOK

public function journal_search($journal_accounts, $from, $to) {
	//$journal_accounts= 'CBZ-ZWL';
	// $from= '2022-11-07';
	// $to= '10-11-2022';
		$this->db->select('*');
		$this->db->from('journal');
		$this->db->where('cashbook = ',  $journal_accounts);
		$this->db->where('date >=', $from);
		$this->db->where('date <=', $to);
		$query = $this->db->get();
				
        return $query;
    }
    public function journal_search_all($from, $to) {
        //$journal_accounts= 'CBZ-ZWL';
        // $from= '2022-11-07';
        // $to= '10-11-2022';
            $this->db->select('*');
            $this->db->from('journal');
            $this->db->where('date >=', $from);
            $this->db->where('date <=', $to);
            $query = $this->db->get();
                    
            return $query;
        }
    /**
     * This function will take the post data passed from the controller
     * If id is present, then it will do an update
     * else an insert. One function doing both add and edit.
     * @param $data
     */
    public function add($data) {
        if (isset($data['id'])) {
            $this->db->where('id', $data['id']);
            $this->db->update('journal', $data);
        } else {
            $this->db->insert('journal', $data);
        }
    }
    public function addtemp($data) {
        if (isset($data['id'])) {
            $this->db->where('id', $data['id']);
            $this->db->update('journaltemp', $data);
        } else {
            $this->db->insert('journaltemp', $data);
        }
    }

    function check_data_exists($data) {
        $this->db->where('journal', $data);

        $query = $this->db->get('journal');
        if ($query->num_rows() > 0) {
            return $query->row();
        } else {
            return FALSE;
        }
    }

    public function class_exists($str) {

        $class = $this->security->xss_clean($str);
        $res = $this->check_data_exists($class);

        if ($res) {
            $pre_class_id = $this->input->post('pre_class_id');
            if (isset($pre_class_id)) {
                if ($res->id == $pre_class_id) {
                    return TRUE;
                }
            }
            $this->form_validation->set_message('class_exists', 'Record already exists');
            return FALSE;
        } else {
            return TRUE;
        }
    }
}
